
;       progam to flash all of PortB pins on and off every 4 seconds



	list      p=16f628A           ; list directive to define processor
	#include <p16F628A.inc>       ; processor specific variable definitions

	errorlevel  -302              ; suppress message 302 from list file

	__CONFIG   _CP_OFF & _LVP_OFF & _BOREN_OFF & _MCLRE_OFF & _WDT_OFF & _PWRTE_ON & _INTOSC_OSC_NOCLKOUT 

; '__CONFIG' directive is used to embed configuration word within .asm file.
; The lables following the directive are located in the respective .inc file.
; See data sheet for additional information on configuration word settings.




;***** VARIABLE DEFINITIONS

	cblock	0x020				  ; address of  1sr ram location bank 0

	w_temp            		      ; variable used for context saving 
	status_temp   			      ; variable used for context saving
	d1,d2,d3					  ; work files for delay subroutine

	endc


;**********************************************************************
	ORG     0x000             ; processor reset vector
	goto    main              ; go to beginning of program
	

	ORG     0x004             ; interrupt vector location  (FUTURE USE)
	movwf   w_temp            ; save off current W register contents
	movf	STATUS,w          ; move status register into W register
	movwf	status_temp       ; save off contents of STATUS register

; isr code can go here or be located as a call subroutine elsewhere


	movf    status_temp,w     ; retrieve copy of STATUS register
	movwf	STATUS            ; restore pre-isr STATUS register contents
	swapf   w_temp,f
	swapf   w_temp,w          ; restore pre-isr W register contents
	retfie                    ; return from interrupt


main						  ; set up Ports to Digital Outputs

	clrf	PORTA			  ; clear ports
	clrf	PORTB
	
	movlw 	0x07			  ; turn off comparators  
	movwf	CMCON

	banksel TRISA			  ; select memory bank1 for TRISA location
	clrf	TRISA			  ; make all ports Outputs
	clrf	TRISB

	banksel 0				  ; return to bank 0
	

mainloop  ; put your code here

	
					

		goto	mainloop



		END